searchNodes=[{"ref":"Booter.html","title":"Booter","type":"module","doc":"Booter allows modules to define a list of boot steps using module attributes. Each step define what to call, what it requires and enables. A directed acyclic graph is then created from theses steps and progressively executed. Why? Complicated applications can be composed of multiple subsystems or groups or processes, independants or dependants of each others. And starting theses subsystems is not easy as :application.start/2 or a supervisor child spec. Inspired/adapted to Elixir by RabbitMQ&#39;s boot process implemented in rabbit.erl and rabbit_misc.erl. For an in-depth explaination, read Alvaro Videla&#39;s article and slides. Usage Defining boot steps Using boot_step/3 macro (recommended): defmodule MyModule do use Booter # without name (__MODULE__ is assumed) boot_step mfa: {mod, fun, args}, requires: :required_step, enables: :another_step # with name boot_step :awesome_name, mfa: {mod, fun, args}, requires: :required_step, enables: :another_step # With name and description boot_step :awesome_name, &quot;Unicorn generator&quot;, mfa: {mod,fun,args}, requires: :rainbow_server, enables: :magic end Or without: defmodule MyModule do Module.register_attribute __MODULE__, :boot_step, accumulate: true, persist: true @boot_step %Booter.Step{name: :awesome_step, description: &quot;Awesome things&quot;, mfa: { :application, :start, [:awesome] }, requires: awesome_step} end Start boot Just call Booter.boot!. Can raise exceptions. Usually called in start/2 of Application behaviour. defmodule MyApp do use Application def start(_) do # Start your main supervisor { :ok, pid } = Supervisor.start_link() # Boot the rest Booter.boot! { :ok, pid } end end"},{"ref":"Booter.html#boot!/1","title":"Booter.boot!/1","type":"function","doc":"Boot the steps"},{"ref":"Booter.html#boot_step/3","title":"Booter.boot_step/3","type":"macro","doc":"Macro to define a boot_step"},{"ref":"Booter.html#module_steps/1","title":"Booter.module_steps/1","type":"function","doc":"List steps of the given module"},{"ref":"Booter.html#modules_steps/1","title":"Booter.modules_steps/1","type":"function","doc":"List steps of the given list of modules"},{"ref":"Booter.html#ordered_modules_steps/1","title":"Booter.ordered_modules_steps/1","type":"function","doc":"List steps of the given modules and order them using ordered_steps/1"},{"ref":"Booter.html#ordered_steps/1","title":"Booter.ordered_steps/1","type":"function","doc":"Orders a list of boot steps"},{"ref":"Booter.Error.CyclicDependency.html","title":"Booter.Error.CyclicDependency","type":"exception","doc":""},{"ref":"Booter.Error.CyclicDependency.html#message/1","title":"Booter.Error.CyclicDependency.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Booter.Error.DuplicateStep.html","title":"Booter.Error.DuplicateStep","type":"exception","doc":""},{"ref":"Booter.Error.DuplicateStep.html#message/1","title":"Booter.Error.DuplicateStep.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Booter.Error.StepError.html","title":"Booter.Error.StepError","type":"exception","doc":""},{"ref":"Booter.Error.StepError.html#message/1","title":"Booter.Error.StepError.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Booter.Error.UnknownDependency.html","title":"Booter.Error.UnknownDependency","type":"exception","doc":""},{"ref":"Booter.Error.UnknownDependency.html#message/1","title":"Booter.Error.UnknownDependency.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Booter.Step.html","title":"Booter.Step","type":"module","doc":"A struct that holds step It contains: name, the step name or the module who defined it, description, an arbitrary description mfa, a tuple containing the module, function and arguments to call, requires, enables, skip, catch, source_file, caller environment location"},{"ref":"Booter.Step.html#fetch/2","title":"Booter.Step.fetch/2","type":"function","doc":"Invoked in order to access the value stored under key in the given term term. This function should return {:ok, value} where value is the value under key if the key exists in the term, or :error if the key does not exist in the term. Many of the functions defined in the Access module internally call this function. This function is also used when the square-brackets access syntax (structure[key]) is used: the fetch/2 callback implemented by the module that defines the structure struct is invoked and if it returns {:ok, value} then value is returned, or if it returns :error then nil is returned. See the Map.fetch/2 and Keyword.fetch/2 implementations for examples of how to implement this callback. Callback implementation for Access.fetch/2."},{"ref":"Booter.Step.html#get/3","title":"Booter.Step.get/3","type":"function","doc":""},{"ref":"Booter.Step.html#get_and_update/3","title":"Booter.Step.get_and_update/3","type":"function","doc":"Invoked in order to access the value under key and update it at the same time. The implementation of this callback should invoke fun with the value under key in the passed structure data, or with nil if key is not present in it. This function must return either {get_value, update_value} or :pop. If the passed function returns {get_value, update_value}, the return value of this callback should be {get_value, new_data}, where: get_value is the retrieved value (which can be operated on before being returned) update_value is the new value to be stored under key new_data is data after updating the value of key with update_value. If the passed function returns :pop, the return value of this callback must be {value, new_data} where value is the value under key (or nil if not present) and new_data is data without key. See the implementations of Map.get_and_update/3 or Keyword.get_and_update/3 for more examples. Callback implementation for Access.get_and_update/3."},{"ref":"Booter.Step.html#pop/2","title":"Booter.Step.pop/2","type":"function","doc":"Invoked to &quot;pop&quot; the value under key out of the given data structure. When key exists in the given structure data, the implementation should return a {value, new_data} tuple where value is the value that was under key and new_data is term without key. When key is not present in the given structure, a tuple {value, data} should be returned, where value is implementation-defined. See the implementations for Map.pop/3 or Keyword.pop/3 for more examples. Callback implementation for Access.pop/2."},{"ref":"Booter.Step.html#t:t/0","title":"Booter.Step.t/0","type":"type","doc":""}]